PAGE 60,132
TITLE FTSE2TXT.EXE FIDO Technology E-Mail Message to Text
; ----------------------------------------------------------------------

;  Syntax      FTSE2TXT Infile Outfile

;              where:   Infile  = d:\Path\FSpec of Input File (*.Msg E-Mail)
;              where:   Outfile = d:\Path\FSpec of Output File (Text Body)

;   Copyright  (c) yyyy   Ben Ritchey Jr., et al
;                         Propriety Licensed use only
;                            All rights reserved

; Note : Place .386 here for 32-bit Segments
               DOSSEG
               .MODEL  small
               .STACK  400h    ; 1kB
; Note : Place .386 here for 16-bit Segments
               .8086           ; Base Architecture
               INCLUDE macro.inc

; ----------------------------------------------------------------------
; 16k Buffer Area (allocated at Pgm Load)
               .DATA?
INREC          DB      16384 DUP(?)
INRECL         EQU     $-INREC

               PAGE
; ----------------------------------------------------------------------
; Data Variables - 59kB Max ( 64kB - .DATA? - .STACK )
               .DATA

; PassThru Buffer Area
PASSBUFF       Label   Byte    ; PassThru Buffer
PBADDR         DD      PASSBUFF  ; Far Ptr to Here!
PBDRIVE        DB      'd'     ; Cur Drive
PBPATH         DB      64 DUP(0)  ; Cur Path
PBFH           DW      0       ; File Handle
PBDTA          DW      0       ; Disk Transfer Addr
PBSDTA         DW      0       ; DTA Seg
PBFSA          DW      0

DTAFIND        DB      30 DUP (?)  ; 256 Byte DTA
DTAFSPEC       DB      226 DUP (?)  ; Offset 30=FSpec

FSPECWC        DB      132 DUP(0)

RUNDS          DW      0       ; Data Seg
RUNES          DW      0       ; Extra Seg
PSPES          DW      0       ; PSP Seg
RUNSP          DW      0       ; Stack OFFSET

INT_SEG        DW      0       ; Interrupts x1k (#x4=Addr)
BIOS_SEG       DW      40h     ; ROM Bios RAM Data
SYS_SEG        DW      0F000h  ; ROM Bios System Code
VBUF_SEG       DW      0B800h  ; Video Buffer Addr
VBUF_MODE      DB      3       ; Video Mode
RESTFLAG       DB      0
VPAGE_LEN      DW      0       ; DOS Screen Bytes

KBSTAT         DW      0       ; Kybd Stat Flag

TERMMSG        DB      'FTSE2Txt terminated, RC=','$'
RCNO           DB      '???','$'

CSR_LOC        Label   Word    ; Cursor Location
CSR_ROW        DB      0       ; Csr Row (0-43)
CSR_COL        DB      0       ; Csr Col (0-131)

ROOT           DB      'd:\',0  ; Root Path
RC             DB      0       ; Return Code
PROCESS        DB      'FTSE2TXT.EXE',0

STDATE         DB      19 DUP (32)
STTIME         DB      11 DUP (32)
STDRIVE        DB      'd:\'
STPATH         DB      63 DUP (32)

INFILE         DB      64 DUP(0)  ; AsciiZ
INFH           DW      0
INBYTES        DW      0

OUTFILE        DB      64 DUP(0)
OUTFH          DW      0
NEWREC         DW      0       ; INREC Buffer Start
OUTBYTES       DW      0       ; Bytes to Write

CRFLAG         DB      0       ; 1=Yes
GOFLAG         DB      0       ; 1=Past Header
EOFLAG         DB      0       ; 1=Eof

               PAGE
; ----------------------------------------------------------------------
; Data Constants
               .CONST

BIOSVID        EQU     10h     ; BIOS Video Int
BIOSEQU        EQU     11h     ;  "   Equipment Flags
BIOSMEM        EQU     12h     ;  "   Memory Size
BIOSDSK        EQU     13h     ;  "   Floppy Disk
BIOSCOM        EQU     14h     ;  "   Communications
BIOSEXT        EQU     15h     ;  "   Extended
BIOSKBD        EQU     16h     ;  "   Keyboard
BIOSPRT        EQU     17h     ;  "   Printer
BIOSRTC        EQU     1Ah     ;  "   Real Time Clock
DOS            EQU     21h     ; DOS Sys Func Req Int

VERSION        DB      CR,LF
               DB      'FTSE2Txt v1.1 FIDO Technology E-Mail Message to Text '
               DB      CR,LF
LEGEND         DB      '  1998 Freeware {IP} Ben Ritchey Jr.'
               DB      CR,LF
               DB      '$'
VERSIONL       EQU     $-VERSION

KEOF           DB      CR,LF
               DB      '{ End of Message }'
CRLF           DB      CR,LF
KEOFL          EQU     $-KEOF
CRLF2          DB      CR,LF,'$'  ; 2nd CrLf must be here !

KFILE          DB      '  In: ','$'
KEXTRACT       DB      '  Out: ','$'
KFROM          DB      'From: '
KSPACES        DB      8 DUP(32)
KDATE          DB      'Date: '

SYNTAXMSG      DB      CR,LF,LF, 'Error : Syntax is FTSE2TXT infile outfile'
               DB      CR,LF,LF, 'where : infile/outfile = d:\Path\FSpec'
               DB      CR,LF,LF, '  and :  infile = FTS *.Msg E-Mail message'
               DB      CR,LF,    '        outfile = Text/Body of message'
               DB      CR,LF,LF, '$'

EMPTYMSG       DB      CR,LF, '*** Error: 1st BLANK Line not found!'
               DB      CR,LF,LF, '$'

HEXTABLE       DB      '0123456789ABCDEF'
DOSVER         DB      'ah.al '
ZERO           DB      0
SPACE          DB      ' '
DOLLAR         DB      '$'
CR             Equ     0Dh
LF             Equ     0Ah

; Memory Map  ( Data Seg = .DATA + .DATA? + .STACK )
;     Seg Name :   HDR   +  PSP  +  Data  +  Code  =   Total
;    Max Alloc :    16   +  256  +  64kB  +  64kB  = 131,344
;   16 =Pages :     1   +   16  +  4096  +  4096  =   8,209
; ( also PSPSeg:0002 xWord = 1st Byte Unused RAM! )
PBPAGES        DW      8209

PATCH          DD      16 DUP(0FFh)  ; 64 Byte Patch

               PAGE
; ----------------------------------------------------------------------
; Mainline Code (Logic Stuff) - 64kB Max
               .CODE

START:         mov     ax,@data  ; Data Seg Addr
               mov     ds,ax
               mov     RUNDS,ax
               mov     es,ax     ; Extra Seg=Data
               mov     RUNES,ax

               cli             ; Stack Seg=Data (Top) 
               mov     ss,ax
               mov     sp,Offset STACK
               sti
               mov     RUNSP,sp

; Free extra RAM
               mov     ah,62h  ; Get PSP Seg
               int     DOS
               mov     PSPES,bx  ; 1st Seg/Page
               mov     es,bx

               mov     ax,RUNDS  ; Calculate ACTUAL Size  <==
               mov     bx,RUNSP  ; Convert Stack Ptr to Paras
               mov     cl,4
               shr     bx,cl   ;   to get Data + Stack (/16)
               inc     bx
               add     ax,bx   ; Add Stack Pages to DS (End of Pgm)
               mov     bx,es   ; Get Start of Program (PSP)
               sub     ax,bx   ; Subtract Start from End
               inc     ax      ; +1 for Ctl Blk
               mov     bx,ax   ; Now actual Seg/Page Size

;               mov     bx,PBPAGES  ; (to Plug Max No. Pages)
               xor     al,al
               mov     ah,4Ah  ; Re-Allocate
               int     DOS
               jnc     @F
               jmp     ERR_SET

; Verify DOS >= 5.0
@@:            @GET_VER
               cmp     al,5
               jge     @F
               mov     al,99
               mov     RC,al
               jmp     ERR_EXIT

@@:            @GET_DTA        ; PSP+80h=Cmd Args
               push    ds
               push    es
               mov     es,RUNES
               mov     di,Offset FSPECWC
               pop     ds      ; Store FSpec
               mov     si,bx
               mov     al,[si]
               cmp     al,1    ; Len=0 if No args
               jg      DOARGS
               pop     ds      ; Restore ds!

SYNERR:        mov     RC,102  ; Syntax Error
               mov     dx,Offset SYNTAXMSG
               @PUT_STR
               jmp     ERR_EXIT

DOARGS:        xor     ch,ch
               mov     cl,al
               dec     cl
               inc     si
               inc     si
               cld
               rep     movsb
               pop     ds
               mov     dx,Offset DTAFIND  ; Private DTA
               @SET_DTA
               PAGE
; ----------------------------------------------------------------------
; Re-entrant
RESTART:       mov     dx,Offset VERSION
               @PUT_STR

               @GET_DRV        ; Cur Drive
               mov     STDRIVE,ah

               @GET_CDI        ; Cur Path
               mov     ds,RUNDS
               mov     cx,63
               mov     si,Offset PBPATH
               mov     di,Offset STPATH
               cld
               rep     movsb

               mov     cx,63   ; Parse File Arg 1
               mov     si,Offset FSPECWC
               mov     di,Offset INFILE
               cld
@@:            lodsb
               cmp     al,' '
               je      FARG2
               jl      SYNERR2
               stosb
               loop    @B
               jmp     SYNERR

FARG2:         cmp     Byte Ptr INFILE,0
               je      SYNERR2
               mov     al,'$'  ; Make AsciiZ + $
               inc     di
               stosb

               mov     cx,63   ; Parse File Arg 2
               mov     di,Offset OUTFILE
@@:            lodsb
               cmp     al,' '
               jle     OKARG
               stosb
               loop    @B
               jmp     SYNERR

SYNERR2:       jmp     SYNERR

OKARG:         cmp     Byte Ptr OUTFILE,0
               jne     @F
               jmp     SYNERR

@@:            mov     al,'$'  ; Make AsciiZ + $
               inc     di
               stosb

               mov     dx,Offset INFILE
               mov     al,0    ; Open Read
               @OPENF
               mov     INFH,ax

               mov     dx,Offset OUTFILE
               mov     cx,0    ; Create or Truncate
               @CREATEF
               mov     OUTFH,ax

               mov     dx,Offset DTAFIND  ; Read FTS Header
               mov     cx,190
               mov     bx,INFH
               @READF

               mov     dx,Offset KFROM  ; Write 'From: '
               mov     cx,6
               mov     bx,OUTFH
               @WRITEF

               mov     dx,Offset DTAFIND  ; Write FromUser
               mov     cx,36
               mov     bx,OUTFH
               @WRITEF

               mov     dx,Offset KSPACES  ; Write Spaces x8
               mov     cx,8
               mov     bx,OUTFH
               @WRITEF

               mov     dx,Offset KDATE  ; Write 'Date: '
               mov     cx,6
               mov     bx,OUTFH
               @WRITEF

               mov     dx,Offset DTAFIND+144  ; Write DateTime + Cr,Lf x2
               mov     cx,20
               mov     bx,OUTFH
               @WRITEF

               mov     dx,Offset CRLF
               mov     cx,4
               mov     bx,OUTFH
               @WRITEF

READNXT:       cmp     EOFLAG,1
               jne     @F
               jmp     ENDIT
@@:            mov     dx,Offset INREC
               mov     cx,INRECL
               mov     bx,INFH
               @READF
               mov     INBYTES,ax
               cmp     ax,INRECL
               je      @F
               mov     EOFLAG,1
@@:            cmp     ax,0
               jne     @F
               jmp     ENDIT
@@:            mov     si,Offset INREC
               cld
               cmp     GOFLAG,1
               je      COPYIT
DATANXT:       cmp     INBYTES,0
               je      READNXT
               lodsb
               dec     INBYTES

;@@:            cmp     al,LF   ; Lf
;               je      @F
               cmp     al,CR   ; C/r
               jne     NOGO

@@:            cmp     CRFLAG,1  ; 2nd Cr is GO!
               je      COPYIT
               mov     CRFLAG,1
               jmp     DATANXT

NOGO:          mov     CRFLAG,0
               jmp     DATANXT

COPYIT:        mov     GOFLAG,1
               cmp     INBYTES,0
               je      READNXT
               mov     NEWREC,si
NXTBYTE:       lodsb
               dec     INBYTES
               inc     OUTBYTES
               cmp     al,26   ; Eof?
               jne     @F
               jmp     ENDIT

@@:            cmp     al,CR   ; End of Line?
               je      NEWLINE
               cmp     INBYTES,0
               jne     NXTBYTE

               mov     dx,NEWREC  ; Write out Partial line
               mov     cx,OUTBYTES
               mov     bx,OUTFH
               @WRITEF

               mov     OUTBYTES,0  ; Next Buffer
               jmp     READNXT

NEWLINE:       mov     dx,NEWREC  ; Write out Current line + Lf
               mov     cx,OUTBYTES
               mov     bx,OUTFH
               @WRITEF

               mov     dx,Offset CRLF+1
               mov     cx,1
               mov     bx,OUTFH
               @WRITEF

               mov     ax,OUTBYTES
               add     NEWREC,ax
               mov     si,NEWREC

;               cmp     si,INRECL  ; Drop LF if Cr/Lf combo!
;               jge     @F
;               cmp     Byte Ptr [si],LF
;               jne     @F
;               inc     NEWREC
;               dec     INBYTES
;               mov     si,NEWREC

@@:            mov     OUTBYTES,0
               jmp     COPYIT

ENDIT:         mov     dx,Offset KEOF  ; Write out 'EOF' Msg
               mov     cx,KEOFL
               mov     bx,OUTFH
               @WRITEF

               mov     dx,Offset CRLF2
               @PUT_STR
               mov     dx,Offset KFILE
               @PUT_STR
               mov     dx,Offset INFILE
               @PUT_STR
               mov     dx,Offset KEXTRACT
               @PUT_STR
               mov     dx,Offset OUTFILE
               @PUT_STR
               mov     dx,Offset CRLF2
               @PUT_STR

               cmp     GOFLAG,1  ; Empty output?
               je      EXITP

               mov     dx,Offset EMPTYMSG  ; Yes
               @PUT_STR
               mov     RC,11
               jmp     EXITP

               PAGE
; ----------------------------------------------------------------------
; Error Handler

ERR_SET:       mov     RC,al   ; Save Err #

ERR_EXIT:      mov     al,RC   ; Error #

; Exit to DOS
EXITP:         cmp     INFH,0
               je      CLOSE2

               mov     bx,INFH
               mov     INFH,0
               @CLOSEF

CLOSE2:        cmp     OUTFH,0
               je      EXIT
               mov     bx,OUTFH
               mov     OUTFH,0
               @CLOSEF

EXIT:          mov     dx,Offset TERMMSG  ; Term Msg
               @PUT_STR

               xor     ax,ax   ; Convert Bin RC to ASCII
               xor     bx,bx
               mov     al,RC
               mov     cx,100  ; Hunds
               div     cl
               mov     bl,al
               mov     al,HEXTABLE[bx]
               mov     RCNO,al
               mov     al,ah   ; Tens
               xor     ah,ah
               mov     cx,10
               div     cl
               mov     bl,al
               mov     al,HEXTABLE[bx]
               mov     RCNO+1,al
               mov     bl,ah   ; Ones
               mov     al,HEXTABLE[bx]
               mov     RCNO+2,al

               cmp     RCNO,'0'  ; Suppress Leading Zeroes
               jne     @F
               mov     ax,Word Ptr RCNO+1
               mov     Word Ptr RCNO,ax
               mov     RCNO+2,' '

@@:            cmp     RCNO,'0'
               jne     @F
               mov     al,RCNO+1
               mov     RCNO,al
               mov     RCNO+1,' '

@@:            mov     dx,Offset RCNO  ; Display ErrorLevel
               @PUT_STR
               mov     dx,Offset CRLF2
               @PUT_STR

               mov     al,RC   ; ErrorLevel = RC
               mov     ah,4Ch
               int     DOS     ; Exit
               ret

               END     START   ; Start Addr!
;*** End of Program ***
